<?php

namespace Drupal\proc\Controller;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Controller\ControllerBase;

/**
 * Controller.
 */
class ProcController extends ControllerBase {

  /**
   * Checks whether the user is a recipient of a PGP message.
   *
   * @param string $user
   *   User IDs as CSV.
   *
   * @return array
   *   Controller response.
   */
  public function checkRecipient($user) {
    $recipients = _proc_get_csv_argument($user);
    $key_id = FALSE;
    foreach ($recipients as $recipient) {
      $query = \Drupal::entityQuery('proc')
        ->accessCheck(TRUE)
        ->condition('user_id', $recipient)
        ->condition('type', 'cipher', '!=')
        ->sort('id', 'DESC')
        ->range(0, 1);
      $key_id = key($query->execute());
      if (!$key_id) {
        return AccessResult::forbidden('User account ' . $recipient . ' does not exist or user is not a holder of PGP keys.');
      }
    }
    return AccessResult::allowed();
  }

}
